#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <libgen.h>
#include <sys/stat.h>

char *include_filename = "minix_options.h";

static int create_table (FILE * f, FILE * write_file) {
	char line[1024], *s;
	char var[256] = "";
	int i;
	int ok = 0;



	while (fgets (line, sizeof (line), f) != NULL) {
		for (i = 0; i < strlen (line); i++)
			if (line[i] == '\n')
				line[i] = 0;

		s = line;

		while (*s == ' ' || *s == '\t') {
			s++;
		}

		if (strncmp (s, "int ", 4) == 0) {
			if (*var != 0)
			{
				fprintf (write_file, "\t{\"%s\", &%s},\n", var, var);
				*var = 0;
			}
			s += 4;

			for (i = 0; i < strlen (line); i++)
				if (line[i] == ';' || line[i] == '=' /*|| line[i] == ' '*/)
					line[i] = 0;
			ok = 1;
			for (i = 0; i < strlen(s); i++) 
				if (s[i] == ' ')
					s[i] = 0;

			strcpy (var, s);
			continue;
		}


		/*
		   s = line;

		   while (*s == ' ' || *s == '\t' || *s == '/' || *s == '*')
		   s++;

		   if (*comment != 0)
		   strcat (comment, "\n");
		   strcat (comment, "# ");
		   strcat (comment, s);
		   */

	}
	if (*var != 0) {
		fprintf (write_file, "\t{\"%s\", &%s},\n", var, var);
	}



	return ok;
}



static int add_var (FILE * f, FILE * write_file) {
	char line[1024], *s;
	char var[256] = "";
	int i;
	int ok = 0;

	while (fgets (line, sizeof (line), f) != NULL) {
		for (i = 0; i < strlen (line); i++)
			if (line[i] == '\n')
				line[i] = 0;

		s = line;

		while (*s == ' ' || *s == '\t') {
			s++;
		}

		if (strncmp (s, "int ", 4) == 0) {
			if (*var != 0)
			{
				fprintf (write_file, "extern int %s;\n", var);
				*var = 0;
			}
			s += 4;

			for (i = 0; i < strlen (line); i++)
				if (line[i] == ';' || line[i] == '=')
					line[i] = 0;
			ok = 1;
			strcpy (var, s);
			continue;
		}


		/*
		   s = line;

		   while (*s == ' ' || *s == '\t' || *s == '/' || *s == '*')
		   s++;

		   if (*comment != 0)
		   strcat (comment, "\n");
		   strcat (comment, "# ");
		   strcat (comment, s);
		   */

	}
	if (*var != 0) {
		fprintf (write_file, "extern int %s;\n", var);
	}

	return ok;
}



	static void
scan_dir (const char *srcdir, const char *modnam, FILE *include_file, int (*function)(FILE * f, FILE * write_f))
{
	char confname[256], tmp[256], line[1024];
	char module[256], *p;
	FILE *conf;
	FILE *f;
	int i;
	struct stat st;

	int check_platform = 0;
	int platform_ok = 0;
	int ok = 0;

	strcpy (module, modnam);
	p = module;
	while (*p)
	{
		if (*p == '.')
			*p = 0;
		else
			p++;
	}

	if (stat (srcdir, &st) == -1)
		return;

	if (!S_ISDIR (st.st_mode))	/* Not a directory? */
		return;

	sprintf (tmp, "%s/.nomake", srcdir);
	if (stat (tmp, &st) != -1)	/* File exists */
		return;			/* Skip this one */

	sprintf (tmp, "%s/.config", srcdir);
	if ((f = fopen (tmp, "r")) != NULL)
	{
		while (fgets (line, sizeof (line) - 1, f) != NULL)
		{
			char *s;
			for (i = 0; i < strlen (line); i++)
				if (line[i] == '\n')
					line[i] = 0;

			s = line;
			while (*s && *s != '=')
				s++;
			if (*s == '=')
				*s++ = 0;

			if (strcmp (line, "OS") == 0 || strcmp (line, "targetos") == 0)
			{
				check_platform = 1;
				if (strcmp (s, "Linux") == 0)
					platform_ok = 1;
				continue;
			}
		}
		fclose (f);
	}

	if (check_platform && !platform_ok && strcmp (modnam, "osscore"))
	{
		return;
	}
#if 0
	/* copy the man pages */
	sprintf (syscmd, "sed 's:CONFIGFILEPATH:%s:g' < %s/%s.man > /tmp/ossman.man",
			confpath, srcdir, module);
	printf ("%s\n", syscmd);
	unlink ("/tmp/ossman.man");
	system (syscmd);

	sprintf (syscmd,
			"./origdir/setup/txt2man -t \"%s\" -v \"Devices\" -s 7  /tmp/ossman.man > prototype/usr/man/man7/%s.7",
			module, module);
	printf ("%s\n", syscmd);
	system (syscmd);
#endif

	sprintf (tmp, "%s/.params", srcdir);
	if ((f = fopen (tmp, "r")) != NULL)
	{
		ok = function (f, include_file);
		if (!ok) {
			printf("copying parameters failed\n");
		}
		fclose (f);
	}
}

int main (int argc, char *argv[]) {
	int ok;
	int i;
	FILE *include_file = NULL;

	if (argc == 1) {
		printf("expect the directories with drivers\n");
		exit (-1);
	}

	if ((include_file = fopen (include_filename, "w")) == NULL) {
		printf("failing to open file %s for writing\n", include_filename);
		exit (-1);
	}

	fprintf(include_file, "#ifndef MINIX_OPTIONS_H\n");
	fprintf(include_file, "#define MINIX_OPTIONS_H\n\n");
	fprintf(include_file, "#include \"minixdefs.h\"\n\n");

	for (i = 1; i < argc; i++) {
		scan_dir(argv[i], basename (argv[i]), include_file, add_var);
	}

	fprintf(include_file, "\n\noption_t option_table[] = {\n");
	for (i = 1; i < argc; i++) {
		scan_dir(argv[i], basename (argv[i]), include_file, create_table);
	}
	fprintf(include_file, "\t{0}\n");
	fprintf(include_file, "};\n");
	fprintf(include_file, "#endif\n");

	fclose(include_file);
	return 0;
}
